<?php
if (!defined('ABSPATH')) {
    die('Access Denied!');
}
if (current_user_can('administrator')) {
    class opeFormPagination
    {
        public static function pagination($perPageRecord = '', $baseUrl = '')
        {
            if (empty($perPageRecord)) {
                echo 'Error: The pagination function requires setting parameters.';
            } else {
                global $wpdb;
                $table_name = $wpdb->prefix . 'opeform_mailbox';
                if (isset($_GET['ope_form_page_number']) && $_GET['ope_form_page_number'] != "") {
                    $ope_form_page_number = $_GET['ope_form_page_number'];
                } else {
                    $ope_form_page_number = 1;
                }

                $category = isset($_GET['ope_form_category']) && is_numeric($_GET['ope_form_category'])
                    ? trim($_GET['ope_form_category'])
                    : '';

                $where = $category ? $wpdb->prepare('WHERE mail_category = %s', $category) : '';

                $total_records = $wpdb->get_var("SELECT COUNT(*) FROM `$table_name` $where");
                if ($total_records > $perPageRecord) {
                    $total_no_of_pages = ceil($total_records / $perPageRecord);
                    return '<div class="opeform-patination">' . paginate_links(array(
                        'base' => add_query_arg('ope_form_page_number', '%#%'),
                        'format' => '',
                        'prev_text' => __('&laquo;', 'ope-form-pack'),
                        'next_text' => __('&raquo;', 'ope-form-pack'),
                        'total' => $total_no_of_pages,
                        'current' => $ope_form_page_number,
                    )) . '</div>';
                } else {
                    return false;
                }
            }
        }
    }
    $opeFormPagination = new opeFormPagination();
    if (isset($_GET['data-page-rows-show']) && is_numeric($_GET['data-page-rows-show'])) {
        $perPage = $_GET['data-page-rows-show'];
    } else {
        $perPage = 20;
    }

    $category = isset($_GET['ope_form_category']) && is_numeric($_GET['ope_form_category'])
        ? trim($_GET['ope_form_category'])
        : '';

    global $wpdb, $ope_form_panel_config;
    date_default_timezone_set(@$ope_form_panel_config->timezone);

    $table_name = $wpdb->prefix . 'opeform_mailbox';
    $ope_form_page_number = isset($_GET['ope_form_page_number']) && is_numeric($_GET['ope_form_page_number']) && $_GET['ope_form_page_number'] > 0
        ? $_GET['ope_form_page_number']
        : 1;

    $offset = ($ope_form_page_number - 1) * $perPage;

    $query_string = isset($_GET['ope_form_search']) && !empty($_GET['ope_form_search'])
        ? $wpdb->esc_like($_GET['ope_form_search'])
        : '';

    $where = $category ? $wpdb->prepare('WHERE mail_category = %s', $category) : '';
    $search_query = !empty($query_string) ? "AND (from_name LIKE '%$query_string%' OR from_email LIKE '%$query_string%' OR mail_data LIKE '%$query_string%')" : '';

    $query = "SELECT * FROM `$table_name` $where $search_query ORDER BY mail_id DESC LIMIT %d, %d";
    $result = $wpdb->get_results($wpdb->prepare($query, $offset, $perPage));

    unset($query_string);

    ?>
    <div class="ope-form-mail-list-wrapper" data-area="email-list">
        <div class="mail-list-head">
            <?php
            if (isset($_GET['ope_form_search']) && !empty($_GET['ope_form_search'])) {
                ?>
                <h2><?php echo __('Search Result', 'ope-form-pack'); ?></h2>
                <?php
            } else {
                ?>
                <h2><?php echo __('Mail List', 'ope-form-pack'); ?></h2>
            <?php } ?>
            <form method="get" action="<?php
            $base_url = (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] == 'on' ? 'https' : 'http') . '://' . $_SERVER['HTTP_HOST'];
            $url = $base_url . $_SERVER["REQUEST_URI"];
            echo $url;
            ?>">
                <?php
                if (isset($_GET['data-page-rows-show'])) {
                    ?>
                    <input type="hidden" name="data-page-rows-show"
                        value="<?php echo htmlspecialchars($_GET['data-page-rows-show']); ?>">
                <?php }
                ?>
                <input type="hidden" name="page" value="<?php echo htmlspecialchars($_GET['page']); ?>">
                <div class="ope-form-search-field">
                    <input type="text" name="ope_form_search"
                        value="<?php echo (isset($_GET['ope_form_search']) && !empty($_GET['ope_form_search'])) ? $_GET['ope_form_search'] : ""; ?>">
                    <input type="image"
                        src="<?php bloginfo('template_url'); ?>/pack/contact-form/mailList/assets/img/magnifying-glass-solid.svg">
                </div>
            </form>
        </div>
        <?php if (!empty($result)) { ?>
            <div class="control-section">
                <?php echo $opeFormPagination->pagination($perPage); ?>
                <div class="actions">
                    <div data-action="del_mail"><?php echo __("Delete", "ope-form-pack"); ?></div>
                    <div data-action="export_selected"><?php echo __("Export Selected", "ope-form-pack"); ?></div>
                    <?php
                    if ($opeFormPagination->pagination($perPage) !== false) {
                        ?>
                        <div data-action="export_all"><?php echo __("Export All", "ope-form-pack"); ?></div>
                        <?php
                    }
                    ?>
                    <div class="data-page-rows-show">
                        <?php echo __("Show per page", 'ope-form-pack'); ?>&nbsp;
                        <form method="get" action="<?php
                        $base_url = (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] == 'on' ? 'https' : 'http') . '://' . $_SERVER['HTTP_HOST'];
                        $url = $base_url . $_SERVER["REQUEST_URI"];
                        echo $url;
                        ?>">
                            <input type="hidden" name="page" value="<?php echo htmlspecialchars($_GET['page']); ?>">
                            <?php
                            if (isset($_GET['ope_form_category'])) {
                                ?>
                                <input type="hidden" name="ope_form_category"
                                    value="<?php echo htmlspecialchars($_GET['ope_form_category']); ?>">
                            <?php } ?>
                            <select name="data-page-rows-show" onchange="this.form.submit()">
                                <option <?php selected('1', $perPage); ?> value="1">1</option>
                                <option <?php selected('10', $perPage); ?> value="10">10</option>
                                <option <?php selected('20', $perPage); ?> value="20">20</option>
                                <option <?php selected('30', $perPage); ?> value="30">30</option>
                                <option <?php selected('50', $perPage); ?> value="50">50</option>
                                <option <?php selected('100', $perPage); ?> value="100">100</option>
                                <option <?php selected('200', $perPage); ?> value="200">200</option>
                            </select>
                        </form>
                    </div>
                    <div class="data-mail-categoies">
                        <?php echo __("Category", 'ope-form-pack'); ?>&nbsp;
                        <form method="get" action="<?php
                        $base_url = (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] == 'on' ? 'https' : 'http') . '://' . $_SERVER['HTTP_HOST'];
                        $url = $base_url . $_SERVER["REQUEST_URI"];
                        echo $url;
                        ?>">
                            <input type="hidden" name="page" value="<?php echo htmlspecialchars($_GET['page']); ?>">
                            <?php
                            if (isset($_GET['data-page-rows-show'])) {
                                ?>
                                <input type="hidden" name="data-page-rows-show"
                                    value="<?php echo htmlspecialchars($_GET['data-page-rows-show']); ?>">
                            <?php }
                            ?>
                            <select name="ope_form_category" onchange="this.form.submit()">
                                <option value=""><?php echo __('All', 'ope-form-pack'); ?></option>
                                <?php
                                global $wpdb;
                                $table_name_terms = $wpdb->prefix . 'opeform_mailbox_terms';
                                $result_terms = $wpdb->get_results("SELECT * FROM `$table_name_terms`");
                                if (!empty($result_terms)) {
                                    $current_term = $_GET['ope_form_category'] ?? '';
                                    foreach ($result_terms as $cat) {
                                        $term_id = $cat->term_id;
                                        $term_name = $cat->term_name;
                                        ?>
                                        <option value="<?php echo $term_id; ?>" <?php selected($term_id, $current_term); ?>>
                                            <?php echo $term_name; ?>
                                        </option>
                                        <?php
                                    }
                                }
                                unset($result_terms);
                                ?>
                            </select>
                        </form>
                    </div>
                </div>
            </div>
            <div class="ope-form-mail-list">
                <?php
                echo '<table>';
                echo '<tr><td><input type="checkbox" id="check_all_1"></td><th>From</th>
    <th>Email</th>
    <th>Date</th>
    <th>Category</th></tr>';
                foreach ($result as $m) {
                    ?>
                    <tr data-row-id="<?php echo @$m->mail_id; ?>">
                        <td><input type="checkbox" value="<?php echo @$m->mail_id; ?>"></td>
                        <td><?php echo @$m->from_name; ?></td>
                        <td><?php echo @$m->from_email; ?></td>
                        <td><?php echo @$m->created; ?></td>
                        <td><?php if (!empty(@$m->mail_category)) {
                            $cat_id = @$m->mail_category;
                            $table_name_terms = $wpdb->prefix . 'opeform_mailbox_terms';
                            $result = $wpdb->get_row("SELECT * FROM `$table_name_terms` WHERE term_id=$cat_id");
                            if (!empty($result)) {
                                echo $result->term_name;
                            }
                        } ?></td>
                    </tr>
                    <?php
                }
                echo '<tr><td><input type="checkbox" id="check_all_2"></td><th>From</th>
    <th>Email</th>
    <th>Date</th>
    <th>Category</th></tr>';
                echo '</table>';
                ?>
            </div>
            <div class="control-section">
                <?php echo $opeFormPagination->pagination($perPage); ?>
                <div class="actions">
                    <div data-action="del_mail"><?php echo __("Delete", "ope-form-pack"); ?></div>
                    <div data-action="export_selected"><?php echo __("Export Selected", "ope-form-pack"); ?></div>
                    <?php
                    if ($opeFormPagination->pagination($perPage) !== false) {
                        ?>
                        <div data-action="export_all"><?php echo __("Export All", "ope-form-pack"); ?></div>
                        <?php
                    }
                    ?>
                </div>
            </div>
        <?php } else {
            echo __("There are no entries to display", "ope-form-pack");
        } ?>
    </div>
    <?php
}